<?php

namespace Importacao\Logic\Integracao\Mastermaq\Classes\Entities;

use Importacao\Logic\Integracao\Mastermaq\Classes\Entities\Tratamento;
    
    class Ferias extends Tratamento{
        public $nr_vinculo;
        public $dt_inicio_aquisicao;
        public $dt_fim_aquisicao;
        public $mes_da_aquisicao;
        public $status_ferias;
        public $qtd_dias_adquiridos = 0;
        public $dt_inicio_gozo;
        public $dt_fim_gozo;
        public $qtd_dias_abonado;
        public $dt_retorno_ferias;

        public function setDt_inicio_aquisicao($var = null){
            $var = $this->tratarData($var);
            $this->dt_inicio_aquisicao = $var->format("d\/m\/Y");
        }
        public function setDt_fim_aquisicao($var = null){
            $var = $this->tratarData($var);
            $this->dt_fim_aquisicao = $var->format("d\/m\/Y");
        }
        public function setMes_da_aquisicao($var = null){
            $this->mes_da_aquisicao = 0;
        }
        public function setDt_inicio_gozo($var = null){
            $var = $this->tratarData($var);
            $this->dt_inicio_gozo = $var->format("d\/m\/Y");
        }
        public function setDt_fim_gozo($var = null, $var2 = null){
            try {
                if($var){
                
                    $var = $this->tratarData($var);

                    if($var2 == 1.5)
                        $var2 = 15;

                    if($var2 != 0)
                        $int = $var2-1;
                    else
                        $int = $var2;

                    $var = $var->add(new \DateInterval("P".$int."D"));
                    $this->dt_fim_gozo = $var->format("d\/m\/Y");
                }

            } catch (\Exception $e) {
                echo $e->getMessage();
            }

        }
        public function setDt_retorno_ferias(){
            
            $var = \DateTime::createFromFormat('d\/m\/Y', $this->dt_fim_gozo);
            $var = $var->add(new \DateInterval('P1D'));
            $this->dt_retorno_ferias = $var->format("d\/m\/Y");
        }

        public function setNr_vinculo($var = null){
            if($var){
                $this->nr_vinculo = $var;
            }
        }
        public function setStatus_ferias($var = null){
            $inicio = \DateTime::createFromFormat('d\/m\/Y', $this->dt_inicio_gozo);
            $fim = \DateTime::createFromFormat('d\/m\/Y', $this->dt_fim_gozo);
            $dif = $inicio->diff($fim);
            $dif = $dif->format('%d')+1;
            if($dif<30){
                if($dif+$this->qtd_dias_abonado == 30){
                    $this->status_ferias = 'GOZADO_INTEGRAL';
                }else{
                    $this->status_ferias = 'GOZADO_PARCIAL';
                }
            }else{
                $this->status_ferias = 'GOZADO_INTEGRAL';
            }
            // if($this->qtd_dias_adquiridos==30){
            //     $this->status_ferias = 'GOZADO_INTEGRAL';
            // }elseif($this->qtd_dias_adquiridos != 0){
            //     $this->status_ferias = "GOZADO_PARCIAL";
            // }
        }
        public function setQtd_dias_adquiridos($var = null){
            if($var){
                $this->qtd_dias_adquiridos = 0;
            }
        }
        public function setQtd_dias_abonado($var = null){
            if($var){
                $this->qtd_dias_abonado = $var;
            }
        }



    }