function Grs15000_ExportacaoNfFaturamentoSap_Controller(ScreenService, templateManager, General, Grs15000_ExportacaoNfFaturamentoSap_Service, ZhFilterPreferences) {
    
    var msg = {
        "SUCESSO"         : "Notas Fiscais exportadas com sucesso.",
        "NOTAS_EXPORTADAS": "Existem notas que ja foram exportadas."
    };
    
    this.openFilterExportacao = function (widget){
        var dataAtual = moment().format('DD/MM/YYYY');
        var start = dataAtual;
        var end   = dataAtual;
        var rowFilter = {};
        
        rowFilter = {
 	        'DTENTRSAID': {start : start, end : end}
 	    };
 	    
 	    
 	    General.callRestEngine("df_saida#/getFilterExportSap", "Row", {}).then((response) => {
 	        if(response.dataset.filter) {
 	            rowFilter.CDEMPRESA = response.dataset.filter.CDEMPRESA;
 	            rowFilter.NMEMPRESA = response.dataset.filter.NMEMPRESA;
 	            rowFilter.CDFILIAL  = [response.dataset.filter.CDFILIAL];
 	            rowFilter.NMFILIAL  = [response.dataset.filter.NMFILIAL];
 	        }
            ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
            ZhFilterPreferences.openFilterWidget(widget, rowFilter);
 	    },
 	    (error) => {
 	        ZhFilterPreferences.setOriginalFilter(widget.id, rowFilter);
            ZhFilterPreferences.openFilterWidget(widget, rowFilter);
 	    });
    };
    
    this.aplicaFiltro = function (widget, preference){
        var rowFiltro = preference.FILTER_ROW;
        var cdfilial  =  rowFiltro.CDFILIAL && rowFiltro.CDFILIAL.length>0 ?   "_" +  rowFiltro.CDFILIAL.toString().replace(/,/g, '_') + "_" : null;

        widget.dataSourceFilter = [
            {            
                "name":"CDEMPRESA",
                "operator":"=",
                "value":rowFiltro.CDEMPRESA
            },
            {
                "name":"DATAINI",
                "operator":"=",
                "value":rowFiltro.DTENTRSAID.start
            },
            {
                "name":"DATAFINAL",
                "operator":"=",
                "value":rowFiltro.DTENTRSAID.end
            },
            {
                "name":"CDFILIAL",
                "operator":"=",
                "value": cdfilial
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        
        if(rowFiltro.IMPORT)
            widget.dataSourceFilter.push(
                {
                    "name":"IMPORT",
                    "operator":"=",
                    "value":rowFiltro.IMPORT
                }
            );
            
        widget.reload();
        this.setStripeData(widget, preference);
    };
    
    this.exportarNf = function (widget){
        if(Grs15000_ExportacaoNfFaturamentoSap_Service.validaStatusNf(widget.getCheckedRows())){
            var rows = Grs15000_ExportacaoNfFaturamentoSap_Service.preparaRow(widget.getCheckedRows());
            General.callRestEngine('df_saida#/exportarNf','Row',rows).then(
                function (response)  {
                   widget.reload();
                   ScreenService.showMessage(msg.SUCESSO);
                },
                function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }  
            );    
        }else
            ScreenService.showMessage(msg.NOTAS_EXPORTADAS);
    };
    
    this.setStripeData = function(widget, preference) {
        var currentRow = preference.FILTER_ROW;
        var stripeWidget = templateManager.container.getWidget("stripe");

        stripeWidget.currentRow = {};
        stripeWidget.currentRow.NMEMPRESA   = currentRow.NMEMPRESA;
        stripeWidget.currentRow.DTENTRSAID  = 'De ' + currentRow.DTENTRSAID.start + ' até ' + currentRow.DTENTRSAID.end;
        stripeWidget.currentRow.CDFILIAL    =  currentRow.CDFILIAL;
        
        stripeWidget.getField('CDFILIAL').isVisible =  stripeWidget.currentRow.CDFILIAL ? true: false;
        
    };
    
    this.verificaEdicao = function (widget){
        widget.getAction('editar').readOnly = widget.currentRow.IMPORT !=='X' &&  widget.currentRow.IDAVISOCREDSAP ==='S' ? false: true; 
    };
    
    
   
    /*******************************************************************************************************
     * Se "Permite informar Aviso de Crédito" --  (this.verificaEdicao())
     * Se Aviso = "SIM " permitir alteração das colunas: Aviso, Cód. Único Aviso, Crédito e Descrição
     ****************************************************************************************************/
     this.HabilitaEdicao = function(widget) {
        if (widget.currentRow.IDAVISO === 'S'){
                widget.getField("CRCREDITO").readOnly = false; 
                  widget.getField("CDUNICOAVISO").readOnly = false; 
                   widget.getField("DSOBSERVCRED").readOnly = false; 
                    widget.getField("IDAVISO").readOnly = false; 
        } else if (widget.currentRow.IDAVISO === 'N'){
                widget.getField("CRCREDITO").readOnly = true; 
                  widget.getField("CDUNICOAVISO").readOnly = true; 
                   widget.getField("DSOBSERVCRED").readOnly = true; 
                    widget.getField("CRCREDITO").value (""); 
                    widget.getField("CDUNICOAVISO").value(""); 
                     widget.getField("DSOBSERVCRED").value(""); 
        } 
    };
    
    this.salvarNotaCredito = function (widget){
        var row = Grs15000_ExportacaoNfFaturamentoSap_Service.preparaRow(widget.currentRow);
        General.callRestEngine('df_saida#/salvarNotaCredito','Row',row).then(
            function (response)  {
                widget.activate();
                widget.view();
            },
            function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }  
        );
    };
    
    // Função criada somente para evitar o erro do zeedhi ao clicar na action no grid
    this.action = function(){};
    

    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("Grs15000_ExportacaoNfFaturamentoSap_Controller", Grs15000_ExportacaoNfFaturamentoSap_Controller);
});
